//+------------------------------------------------------------------+
//|                                                     ADX Slope.mq4|
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_separate_window

#property indicator_buffers 7

#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Yellow
#property indicator_color4 Red
#property indicator_color5 Red

#property indicator_width1 1

#property indicator_width2 3

#property indicator_width3 3

#property indicator_width4 1

#property indicator_width5 1

//
//
//
//
//

extern int    ADXPeriod   = 14;


//
//
//
//
//

double ADX[];
double ADXua[];
double ADXub[];
double ADXda[];
double ADXdb[];

double ADXPlus[];
double ADXMinus[];





//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//



int init()
{
   IndicatorShortName("("+ADXPeriod+") ");
   
   SetIndexBuffer(0,ADX);
   SetIndexBuffer(1,ADXua);
   SetIndexBuffer(2,ADXub);
   SetIndexBuffer(3,ADXda);
   SetIndexBuffer(4,ADXdb);
   SetIndexBuffer(5,ADXPlus);
   SetIndexBuffer(6,ADXMinus);
   
   SetIndexStyle(5, DRAW_NONE);
   SetIndexStyle(6, DRAW_NONE);

   return(0);
}

//
//
//
//
//

int start()
{ 
   int      counted_bars=IndicatorCounted();
   int      limit,i;



   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;

  // limit = MathMin(Bars-counted_bars,Bars-1);
     limit = Bars-counted_bars;
     
   ADXua[i] = EMPTY_VALUE;      ADXub[i] = EMPTY_VALUE;
   ADXda[i] = EMPTY_VALUE;      ADXdb[i] = EMPTY_VALUE;


   //
   //
   //
   //
   //



   if (ADX[limit] > ADX[limit+1]) CleanPoint(limit,ADXua,ADXub);
   if (ADX[limit] < ADX[limit+1]) CleanPoint(limit,ADXda,ADXdb);

   for(i = limit; i >= 0; i--)
   {
         ADX[i]=iADX(NULL, 0,ADXPeriod, PRICE_CLOSE, MODE_MAIN, i);
         ADXPlus[i]=iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_PLUSDI, i);
         ADXMinus[i]=iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_MINUSDI, i);
         
         if (ADX[i] > ADX[i+1]) PlotPoint(i,ADXua,ADXub,ADX);
         
         
         if (ADX[i] < ADX[i+1]) PlotPoint(i,ADXda,ADXdb,ADX);
   }   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//



void CleanPoint(int i,double& first[],double& second[])

{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;

}


//
//
//
//
//



void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }

}